package com.zt.plat.module.contractorder.service.purchaseorder;

import java.util.*;

import com.zt.plat.module.contractorder.controller.admin.purchaseorder.vo.PrchOrdDtlPageReqVO;
import com.zt.plat.module.contractorder.controller.admin.purchaseorder.vo.PrchOrdDtlRespVO;
import com.zt.plat.module.contractorder.controller.admin.purchaseorder.vo.PrchOrdDtlSaveReqVO;
import com.zt.plat.module.contractorder.dal.dataobject.purchaseorder.PrchOrdDtlDO;
import jakarta.validation.*;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.PageParam;

/**
 * 采购订单明细 Service 接口
 *
 * @author 后台管理-1
 */
public interface PrchOrdDtlService {

    /**
     * 创建采购订单明细
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    PrchOrdDtlRespVO createPrchOrdDtl(@Valid PrchOrdDtlSaveReqVO createReqVO);

    /**
     * 更新采购订单明细
     *
     * @param updateReqVO 更新信息
     */
    void updatePrchOrdDtl(@Valid PrchOrdDtlSaveReqVO updateReqVO);

    /**
     * 删除采购订单明细
     *
     * @param id 编号
     */
    void deletePrchOrdDtl(Long id);

    /**
    * 批量删除采购订单明细
    *
    * @param ids 编号
    */
    void deletePrchOrdDtlListByIds(List<Long> ids);

    /**
     * 获得采购订单明细
     *
     * @param id 编号
     * @return 采购订单明细
     */
    PrchOrdDtlDO getPrchOrdDtl(Long id);

    /**
     * 获得采购订单明细分页
     *
     * @param pageReqVO 分页查询
     * @return 采购订单明细分页
     */
    PageResult<PrchOrdDtlDO> getPrchOrdDtlPage(PrchOrdDtlPageReqVO pageReqVO);

    /**
     * 批量创建采购订单明细
     *
     * @param createReqVOS 创建信息
     * @return List<PrchOrdDtlRespVO>
     */
    List<PrchOrdDtlRespVO> batchCreatePrchOrdDtl(@Valid List<PrchOrdDtlSaveReqVO> createReqVOS);
    /**
     * 批量更新采购订单明细
     *
     * @param createReqVOS 更新信息
     * @return List<PrchOrdDtlRespVO>
     */
    List<PrchOrdDtlRespVO> batchUpdatePrchOrdDtl(@Valid List<PrchOrdDtlSaveReqVO> createReqVOS);
    /**
     * 批量删除采购订单明细
     *
     * @param ordIds 编号
     */
    void deletePrchOrdDtlListByOrdIds(List<Long> ordIds);

    List<PrchOrdDtlDO> getDetailsByOrderId(Long ordId);

    void submitErp062ByDelete(List<Long> ids);
}
